
#  Copyright (C) 2008-2010 Freescale Semiconductor, Inc.
# 
#  Redistribution and use in source and binary forms, with or without
#  modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
# NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

TMP_DIR=/tmp/$(USER)
MOUNT_POINT=$(TMP_DIR)/rootfs
APP_ELF=$(APP).elf
APP_DEBUG_ELF=$(APP)_debug.elf
APP_MAP=$(APP).map

PREFIX ?= /usr/local
SYSROOT ?= /usr/local
INSTALL_DIR = $(DESTDIR)/$(PREFIX)/$(SUBDIRNAME)

all:
	$(MAKE) -C dp
	$(MAKE) -C cp


clean:
	$(MAKE) -C dp clean
	$(MAKE) -C cp clean
	rm -rf Documentation/html Documentation/rtf Documentation/*.log
	rm -rf $(BUILD_DIR) $(TMP_DIR)

install:
	mkdir -p $(INSTALL_DIR)
	mkdir -p $(TOP)/bin/$(APP)_test
	mkdir -p $(TOP)/bin/$(APP)_test/pcap
	cp dp/*.elf $(INSTALL_DIR)
	cp cp/$(APP) $(INSTALL_DIR)/$(APP)
	if [ -f cp/sample.xml ]; then cp cp/*.xml $(INSTALL_DIR); fi
	if [ -d cp/p4080 ]; then cp -R cp/p4080 $(INSTALL_DIR); fi
	if [ -d cp/p3041 ]; then cp -R cp/p3041 $(INSTALL_DIR); fi
	if [ -f cp/$(APP)_script.sh ]; then install -m 777 cp/*script.sh $(INSTALL_DIR); fi
	if [ -f dat/$(APP)_text.dat ]; then cp dat/*text.dat $(INSTALL_DIR); fi
	if [ -d scripts ]; then cp -R scripts/* $(TOP)/bin/$(APP)_test ; fi
	chmod -R 777 $(TOP)/bin/$(APP)_test
	if [ -d pcap ]; then install -m 644 pcap/* $(TOP)/bin/$(APP)_test/pcap; fi
	if [ -f cp/ipsa_pattern ]; then install -m 644 cp/ipsa_pattern* $(INSTALL_DIR); fi
	if [ -f cp/spa_pattern ]; then install -m 644 cp/*_pattern $(INSTALL_DIR); fi
doc:
	doxygen Documentation/$(APP).dox
	doxygen Documentation/releasenotes.dox
