# Common Makefile include file for all lwe_apps control plane apps
#
# Copyright (C) 2008-2011 Freescale Semiconductor, Inc.
# 
#  Redistribution and use in source and binary forms, with or without
#  modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
# NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

CROSS_COMPILE ?= powerpc-linux-gnu-

CC ?= $(CROSS_COMPILE)gcc
AS ?= $(CROSS_COMPILE)as

PREFIX ?= /usr/local
SYSROOT ?= /usr/local
O ?= $(DESTDIR)

CC_OPTS += -m32 -Wa,-me500mc -I.  \
		-g -std=gnu99

CC_OPTS_C= -Wall \
  -Wundef \
  -Wstrict-prototypes \
  -Wno-trigraphs \
  -fno-strict-aliasing \
  -fno-common \
  -O3 \
  -pipe \
  -ffixed-r2 \
  -mmultiple \
  -mno-altivec \
  -funit-at-a-time \
  -mno-string \
  -fomit-frame-pointer \
  -Wno-unused \
  -fno-builtin \
  -mbig-endian \
  -mcpu=e500mc \
  -Werror 

LD ?= $(CROSS_COMPILE)ld
MKDIR=mkdir -p

APP_SRCS = $(wildcard *.c)

APP_OBJS = $(basename $(APP_SRCS))
APP_OBJS := $(APP_OBJS:%=%.o)

APP_OBJS += $(LIB_OBJS)

APP_DEPS := $(APP_OBJS:%.o=%.d)

CC_OPTS+=-I$(APP_DIR)/include 

all:	$(APP)

# compile and gen dependency file
%.o:	 %.c
	$(CC) $(LIBC_INC) $(LIBC_CC_OPTS) $(CC_OPTS) $(CC_OPTS_C) -MD -c -o $@ $<
%_$(APP)_cp.o:	 %.c
	$(CC) $(LIBC_INC) $(LIBC_CC_OPTS) $(CC_OPTS) $(CC_OPTS_C) -MD -c -o $@ $<

$(APP):	$(APP_OBJS)
	$(CC) -o $@ $(APP_OBJS)
	rm -rf $(LIB_OBJS) $(APP_DEPS)

clean:
	rm -rf $(APP_OBJS) $(APP) $(APP_DEPS)

-include $(APP_DEPS)

.PHONY: clean
