#!/bin/bash
# Removes virtual network under user mode linux

# Copyright (c) 2009, Freescale Semiconductor, Inc.
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#     * Redistributions of source code must retain the above copyright
#     notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#     notice, this list of conditions and the following disclaimer in the
#     documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY Freescale Semiconductor ``AS IS'' AND ANY
# EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL Freescale Semiconductor BE LIABLE FOR ANY
# DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

ME=`whoami`
TUNCTL=$NETKIT_HOME/bin/tunctl

sudo pkill -u $ME netkit-kernel
sudo pkill -u $ME port-helper

i=0
fm=0
eth=0
while [ $i -le 9 ]
do
	PC="pc"$i
        TRUNK=$ME"-f"$fm"e"$eth
        LINK=$ME-"tk"$i
	BRIDGE=$ME-"wire"$i

	rm $HOME/$PC".disk"  > /dev/null 2<&1

	sudo ifconfig $BRIDGE down
	sudo brctl delif $BRIDGE $LINK
	sudo brctl delif $BRIDGE $TRUNK

	sudo brctl delbr $BRIDGE

	sudo $TUNCTL -d $TRUNK
	sudo $TUNCTL -d $LINK

        i=`expr $i + 1`
	eth=`expr $eth + 1`

	if [ $i -eq 5 ]
	then
		fm=1
		eth=0
	fi
done

