/**
 \file fman_test.h
 \brief Common datatypes, hash-defines and function prototypes of FMAN Test application
 */
/*
 * Copyright (C) 2009-2010 Freescale Semiconductor, Inc.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
 * NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 * TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
#ifndef _FMAN_TEST_H
#define _FMAN_TEST_H

#include "compat.h"
#include "fsl_qman.h"
#include <io.h>
#include <bitops.h>
#include <init.h>
#include <misc.h>
#include <errno.h>
#include <statistics.h>
#include <mmap.h>
#include "sg_api.h"
#include <app_common.h>
#include <dpa_alloc.h>
#include <dpa/dpa_eth.h>
#include <ethernet/eth.h>
#include "ip/ip.h"
#include <ether.h>

#define HASH_MASK	32	/* No. of FQs in PCD range */
#define FMTEST_SHUTDOWN_TIMER_MS	50

#define IP_DOTTED_QUAD(ip)  (ip)>>24, ((ip)&0x00ff0000)>>16, ((ip)&0x0000ff00)>>8, ((ip)&0x000000ff)

/*State of Fman Tester application*/
enum application_state {
	INVALID,
	INITIALIZING,
	RUNNING,
	SHUTDOWN_PENDING,
	SHUTDOWN_RX_COMPLETE,
	SHUTDOWN_COMPLETE
};

#endif /* _FMAN_TEST_H */
