#!/bin/sh

#
#  Copyright (C) 2010 Freescale Semiconductor, Inc.
#
#  Redistribution and use in source and binary forms, with or without
#  modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
# NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

# The script creates routes for ipsec encap application in generator mode

# 6 * 22 = 132 flows for each 1G port
k=500
i=2
while [ "$i" -le "7" ]
do
	j=2
	while [ "$j" -le "23" ]
	do
		./ipsecfwd_hybrid -A -s  192.168.24.$i -d  192.168.29.$j  -g  192.168.24.1  -G  192.168.24.2 -i $k -r out
		k=`expr "$k" "+" "1"`
		j=`expr "$j" "+" "1"`
	done
	i=`expr "$i" "+" "1"`
done

i=2
while [ "$i" -le "7" ]
do
	j=2
	while [ "$j" -le "23" ]
	do
		./ipsecfwd_hybrid -A -s  192.168.29.$i -d  192.168.21.$j  -g  192.168.29.1  -G  192.168.29.2 -i $k -r out
		k=`expr "$k" "+" "1"`
		j=`expr "$j" "+" "1"`
	done
	i=`expr "$i" "+" "1"`
done

i=2
while [ "$i" -le "7" ]
do
	j=2
	while [ "$j" -le "23" ]
	do
		./ipsecfwd_hybrid -A -s  192.168.21.$i -d  192.168.22.$j  -g  192.168.21.1  -G  192.168.21.2 -i $k -r out
		k=`expr "$k" "+" "1"`
		j=`expr "$j" "+" "1"`
	done
	i=`expr "$i" "+" "1"`
done

i=2
while [ "$i" -le "7" ]
do
	j=2
	while [ "$j" -le "23" ]
	do
		./ipsecfwd_hybrid -A -s  192.168.22.$i -d  192.168.23.$j  -g  192.168.22.1  -G  192.168.22.2 -i $k -r out
		k=`expr "$k" "+" "1"`
		j=`expr "$j" "+" "1"`
	done
	i=`expr "$i" "+" "1"`
done

#484 + 12 for 10G port
i=2
while [ "$i" -le "23" ]
do
	j=2
	while [ "$j" -le "23" ]
	do
		./ipsecfwd_hybrid -A -s  192.168.23.$i -d  192.168.24.$j  -g  192.168.23.1  -G  192.168.23.2 -i $k -r out
		k=`expr "$k" "+" "1"`
		j=`expr "$j" "+" "1"`
	done
	i=`expr "$i" "+" "1"`
done

j=2
while [ "$j" -le "23" ]
do
	./ipsecfwd_hybrid -A -s  192.168.23.$i -d  192.168.24.$j  -g  192.168.23.1  -G  192.168.23.2 -i $k -r out
	k=`expr "$k" "+" "1"`
	j=`expr "$j" "+" "1"`
done

./ipsecfwd_hybrid -O
