#!/bin/bash
# Creates virtual network under user mode linux for ipsecfwd app

# Copyright (c) 2010 Freescale Semiconductor, Inc.
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#     * Redistributions of source code must retain the above copyright
#     notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#     notice, this list of conditions and the following disclaimer in the
#     documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY Freescale Semiconductor ``AS IS'' AND ANY
# EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL Freescale Semiconductor BE LIABLE FOR ANY
# DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

TUNCTL=$NETKIT_HOME/bin/tunctl
ME=`whoami`
mkdir -p $HOME/.netkit/mconsole/

i=0
fm=0
eth=0
PORT_NO=8000

if [ $# -eq 1 ]
then
PORT_NO=$1
fi

arr=(0 0 0 0 0 192.168.24.50 192.168.29.60 192.168.21.70 192.168.22.80 \
	192.168.23.90 )

while [ $i -le 9 ]
do
	TRUNK=$ME-"f"$fm"e"$eth
	LINK=$ME-"tk"$i
	BRIDGE=$ME-"wire"$i
	PC="pc"$i

	if [ $i -eq 1 ]
	then
		IP="192.168.10.11"
	else
		IP=${arr[$i]}
	fi

	TITLE=$PC":"$IP

	COMMAND="$NETKIT_HOME/kernel/netkit-kernel \
		 modules=$NETKIT_HOME/kernel/modules name=$PC umid=$PC \
		mem=20M ubd0=$HOME/$PC.disk,$NETKIT_HOME/fs/netkit-fs \
		root=98:1 uml_dir=$HOME/.netkit/mconsole \
		eth0=tuntap,$LINK,,0.0.0.0 autoconf_eth0=$IP \
		hosthome=$HOME quiet con0=fd:0,fd:1 con1=port:$PORT_NO \
		SELINUX_INIT=0"

	sudo $TUNCTL -t $LINK -u $ME > /dev/null 2<&1
	sudo $TUNCTL -t $TRUNK -u $ME > /dev/null 2<&1
	sudo ifconfig $LINK promisc up > /dev/null 2<&1
	sudo ifconfig $TRUNK promisc up > /dev/null 2<&1

	sudo brctl addbr $BRIDGE
	sudo ifconfig $BRIDGE up
	sudo brctl addif $BRIDGE $LINK
	sudo brctl addif $BRIDGE $TRUNK

	if [ $i -ne 4 ] && [ $i -ne 0 ] && [ $i -ne 2 ]  && [ $i -ne 3 ]
	then
		echo Starting $PC connected to $TRUNK ...
		xterm  -sl 5000 -sb -bg beige -title $TITLE -e $COMMAND &
	fi

	PORT_NO=`expr $PORT_NO + 4`
	i=`expr $i + 1`
	eth=`expr $eth + 1`

	if [ $i -eq 5 ]
	then
		fm=1
		eth=0
	fi
done

