#!/usr/bin/env python
# 
#  Copyright (C) 2009 Freescale Semiconductor, Inc.
# 
#  Redistribution and use in source and binary forms, with or without
#  modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
# NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

import sys
import os
from scapy.all import *

# Inputs:
#pcap file to generate
pcap_file="pkts.pcap"
#Payload File

payload_file="pay.load"
payload_size=100

src_mac="00:01:02:00:02:01"
dst_mac="00:01:02:00:02:02"

vlan_range=range(4,6)

src_ip_range=["192.166.1.1","192.166.1.2"]

dst_ip_range=[]
for i in range(10,13):
	ip="%s%s"%("192.166.1.",i)
	dst_ip_range.append(ip)

sport_range=range(44,46)
dport_range=range(55,56)


#make ip pkt 
#inputs: vlan_rangea, ,src_ip_range, dst_ip_range, sport_range, dport_range.
#output ip packets with the above fields set.

def make_pkt(vlan_range,src_ip_range, dst_ip_range, sport_range, dport_range):
	pkt=Ether(src = src_mac,dst = dst_mac)/Dot1Q(vlan = vlan_range)/IP(src = src_ip_range,dst = dst_ip_range)/UDP(sport = sport_range, dport=dport_range)
	pkt.display()
	return pkt

#add payload to the pcaket 
#inputs:pkt, payload file and payload size in bytes.
#output : pkt with payload added.

def add_pay_load(pkts, payload_file, size):
	all_pkts = [p for p in pkts]
	num_pkts = len(all_pkts)
	i = 0
	if os.path.isfile(payload_file):
		fh = open(payload_file,"rb")
		# add payload.
		for p in all_pkts:
			i = i+1
			load = fh.read (size)
			if len(load) != size:
				print "Not enough data in %s"%payload_file
				print "Payload added in %s packets out of %s"%(i,num_pkts)
				break
			p.payload.add_payload(load)
		fh.close ()
	else:
		print "payload file not found"
	return all_pkts



# make ip pkt
pkt=make_pkt(vlan_range,src_ip_range, dst_ip_range, sport_range, dport_range)

# add payload
all_pkts=add_pay_load(pkt, payload_file, 100)

# write to a pcap file
wrpcap(pcap_file, all_pkts)

# send pkts
#sendp(pkt,iface='e0')


