/**
 \file dpa_bman.h
 \brief Header file defining structure of DPA Bman nodes.
 */
/*
 * Copyright (C) 2009-2010 Freescale Semiconductor, Inc.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
 * NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 * TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef __DPA_BMAN_H__
#define __DPA_BMAN_H__

#include <stdbool.h>
#include <fsl_bman.h>

#ifdef __cplusplus
	extern "C" {
#endif

#define MAX_NUM_BMAN_POOLS	64

struct dpa_bpool_t {
	uint32_t size;
};

extern struct dpa_bpool_t dpa_bpools[MAX_NUM_BMAN_POOLS];

extern int get_bpid_bpsize(uint32_t, uint32_t *, uint32_t *);
extern uint32_t get_report_size(uint32_t, uint32_t);
extern int dpa_bpool_init(void);
extern int32_t get_maxsize_bpool(uint32_t * bpsize, uint8_t * bpid);

#ifdef __cplusplus
	}
#endif

#endif
