/**
\file	pktwire.h
\brief	Common datatypes and hash-defines related to Pktwire application
*/
/*
 * Copyright (C) 2008-2010 Freescale Semiconductor, Inc.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
 * NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 * TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef __PKTWIRE_H
#define __PKTWIRE_H

#include <stdlib.h>
#include <io.h>
#include <errno.h>
#include <bitops.h>
#include <init.h>
#include <mmap.h>
#include <sg_api.h>
#include <dpa_alloc.h>
#include <fsl_qman.h>
#include <ip/ip.h>
#include <fm_types.h>

#define PKTWIRE_SHUTDOWN_TIMER_MS	50

/*State of pktwire application*/
enum application_state {
	INVALID,
	INITIALIZING,
	RUNNING,
	SHUTDOWN_PENDING,
	SHUTDOWN_RX_COMPLETE,
	SHUTDOWN_COMPLETE
};

struct pkt_annot {
	struct qman_fq *orp_fq;	/* ORP FQ Pointer */
	uint16_t seq;	/* Sequence Number of Packet */
	uint8_t reserved[10];
	struct output_parse_result_t parse;
} __attribute__ ((packed));
#endif /* __PKTWIRE_H */
