# Copyright (C) 2010 Freescale Semiconductor, Inc.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
# NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


# This script connects to the linux partition running on the mux server
# and dumps its log in simple_crypto.linux.log file

from mux_server_client import *
import sys
import config
import time
import pexpect
import os

app_name = "simple_crypto.elf"
app_dir = "/opt/lwe_apps/simple_crypto/"

def login(host, port, buf_size, buf_num, algo, loop ):
        # create socket and connect to the server
        tcp_sock = conn_server(host, port)

        # open file for dumping logs 
        fd = open_file("logs/" + host + "_" + str(algo) + "_" + str(buf_size) + "_" + str(buf_num) + "_" + str(loop) + "_log/simple_crypto.linux.log")

        # start the login sequence and send commands
        expect_and_send(tcp_sock, "ogin:", "root\n", fd)
	expect_and_send(tcp_sock, "assword:", "root\n", fd)

	i=1
        tcp_sock.close()
        fd.close()


def linux_partition(host, port, core_mask, test_mode, buf_size, test_set, buf_num, algo, loop):
	#login to the linux console
	login(host, port, buf_size, buf_num, algo, loop )

	# spawn the telnet session to the mux server linux port
	p=pexpect.spawn("telnet " + host + " " + str(port))
	p.timeout = 10

	# open file for dumping logs
	fd = open("logs/" + host + "_" + algo + "_" + buf_size + "_" + buf_num + "_" + loop + "_log/simple_crypto.linux.log", "a")

	p.logfile_read = fd

	p.sendline("")
	if p.expect(["#", pexpect.TIMEOUT]) == 1:
		login(host, port, buf_size, buf_num, algo, loop )

	p.sendline("cd " + app_dir)
	p.expect("#")
	if int(test_mode) == 1:
		p.sendline("./simple_crypto -m 1 " + "-s " + buf_size + " -o " + algo + " -n " + buf_num + " -l " + loop)
		time.sleep(15)
	elif int(test_mode) == 2:
		p.sendline("./simple_crypto -m 2 " + " -t " + test_set +  " -o " + algo + " -n " + buf_num + " -l " + loop)
		time.sleep(15)
	p.expect("#")
	p.sendline("partman setprop -h `partman status | grep lwe | head -1 | awk \'{print $2}\'` -p chosen -n bootargs -t \"coremask=" + core_mask + "\"")
	p.expect("#")
	p.sendline("partman start -h  `partman status | grep lwe | head -1 | awk \'{print $2}\'`" + " -f ./" + app_name)
	p.expect("SEC4.0 test parameters are valid, start DP application")
	p.expect("#")
	p.sendline("")

	# close log file
	p.close()
	fd.close()
