# Copyright (C) 2010 Freescale Semiconductor, Inc.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN
# NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


# This is a client to connect to the mux_server utility. It can be used
# instead of the regular xtel utility, which opens interactive consoles
# and communicates with the mux_server via telnet/socat. This client is
# for use in a regression context where interactive sessions are not
# required. The client basically enables expect-like behaviour without
# actually using expect or Tcl.

from socket import *
import sys
import re

# open file for dumping logs
def open_file(f_name):
	fd = open(f_name, "a+")
	return fd

# connect to server and return the socket pointer
def conn_server(host, port):
	tcp_sock = socket(AF_INET, SOCK_STREAM)
	if tcp_sock.connect((host, port)):
		print "TCP Connect failed to", host, ":", port
		exit(-1)
	return tcp_sock

# expect a string on the socket and when it comes, send a given string
# e_str is the expected string and s_str is the string to send
def expect_and_send(tcp_sock, e_str, s_str, fd):
	while 1:
		data = tcp_sock.recv(1024)
		fd.write(data)
		fd.flush()
		fd.seek(0, 0);
		lines = fd.readlines()
		if len(lines):
			line = lines[-1]
			if (re.search(e_str, line)):
				if not tcp_sock.send(s_str):
					print "Error sending command to server"
				else:
					break
