#!/usr/bin/python
# Copyright (C) 2010 Freescale Semiconductor, Inc.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
# NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

import config
import os
import sys

cmd_string = "rm -rf logs"
os.system(cmd_string)

os.system("mkdir logs")
fd = open("logs/common.log", "a")

if config.run_on_simics and config.run_on_board \
		or not(config.run_on_simics) and not(config.run_on_board) :
	fd.write("Select one option either board or simics")
	fd.close()
	sys.exit(1)

if config.run_on_simics == 1:
	crypto_test_cmd = "./crypto_test.py -s " + config.simics_port + " -m " + config.mux_server_path + " -h " + config.host_ip_address + " -p " + config.port_start_num + " -c " + config.coremask + " -P " + config.simics_cmd + " -w " + config.simics_workspace 
elif config.run_on_board == 1 :
	crypto_test_cmd = "./crypto_test.py -b " + config.board_name + " -m " + config.mux_server_path + " -h " + config.host_ip_address + " -p " + config.port_start_num + " -c " + config.coremask + " -u " + config.userid

#Simple Crypto in Perf Mode
for algo in range (1, 9):			#all SEC algos supported by simple crypto
	for buf_size in [64, 128, 1024]:	#buffer size 64, 128 and 1024
		for buf_num in [64, 128, 1024]:	#no of buffers 64, 128 and 1024
			for iterations in [64, 128]:	#loops 64 and 128
				fd = open("logs/common.log", "a")
				fd.write("running script(Perf mode): " + crypto_test_cmd + " -r b27504" + "-M 1 -S " + str(buf_size) + " -N "+ str(buf_num) + " -O " + str(algo) + " -L " + str(iterations) + "\n")
				fd.close()
				os.system(crypto_test_cmd + " -r b27504 -M 1 -S " + str(buf_size) + " -N " + str(buf_num) + " -O " + str(algo) + " -L " + str(iterations))
				fd = open("logs/common.log", "a")
				fd.write("\n\n\n\n")
				fd.close()

#Simple Crypto in Cipher Mode
for algo in range (1, 9):			#all SEC algos supported by simple crypto
	for test_set in range (1, 6):		#test set number
		if algo == 1 and test_set > 4 :
			continue
		if (algo == 2 or algo == 8) and test_set > 2 :
			continue
		print "running script(Cipher mode): " + crypto_test_cmd + " -M 2 -T " + str(test_set) + " -N 1000 -O " + str(algo) + " -L 2"
		os.system(crypto_test_cmd + " -M 2 -T " + str(test_set) + " -N 1000 -O " + str(algo) + " -L 2")
