#!/usr/bin/python
# Copyright (C) 2010 Freescale Semiconductor, Inc.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
# NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


# This script is simics specific

import os
import time
import pexpect
import commands
import config

p=0
fd=0
mux_server=""


def run_simics(host, algo, buf_size, buf_num, loop, simics_cmd, ws_path):
	global p

	path = os.getenv("PATH") + ":" + ws_path
	os.environ["PATH"] = path

	p=pexpect.spawn(simics_cmd)
	fd = open("logs/" + host + "_" + str(algo) + "_" + str(buf_size) + "_" + str(buf_num) + "_" + str(loop) + "_log/simics.log", "w")

	p.timeout=1000000
	p.logfile=fd

	p.expect("simics>")
	p.sendline("c")
	p.expect("running>")
	p.expect("[p4080ds.soc.pamu[4] s")
	time.sleep(20)

def quit_simics():
	global p
	p.sendline("q")

def run_mux(m_path, s_port, mux_port_string):
	mux_server_command = m_path + "/mux_server localhost:" + str(s_port) + " " + mux_port_string + "& \n"
	os.system(mux_server_command)
	time.sleep(1)

def kill_ps_mux_simics():
	global mux_server
	mux_server="/mux_server localhost:" + str(s_port) + " " + mux_port_string
	kill_command="kill -9 'ps -eo pid,user,cmd | grep " + str(user) + " | grep \"" + mux_server + "\"  |grep -v grep | head -1 | cut -c 1-5'"

	os.system(kill_command)
