# Copyright (C) 2010 Freescale Semiconductor, Inc.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
# NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

import sys
import time
import pexpect

def reset_hv(host, port, algo, buf_size, buf_num, loop):
	fd2 = open("logs/common.log", "a")
	p=pexpect.spawn("telnet " + host + " " + str(port))
	p.timeout = 40

	fd = open("logs/" + host + "_" + algo + "_" + buf_size + "_" + buf_num + "_" + loop + "_log/simple_crypto.uboot.log", "a")
	p.logfile_read = fd

	p.sendline("")
	p.sendline("")
	fd2.write("reset on hv prompt\n")
	p.expect("HV>")
 	p.sendline("reset")
	p.expect("=> ")
	p.close()
	fd2.write("reset done\n")
	fd2.close()

def start_uboot(host, port, algo, r_flag, r_path, buf_size,  buf_num, loop):
	fd2 = open("logs/common.log", "a")
	bank4=0

	# spawn the telnet session to the mux server linux port
	p=pexpect.spawn("telnet " + host + " " + str(port))
	p.timeout = 1000000

	# open file for dumping logs
	fd = open("logs/" + host + "_" + algo + "_" + buf_size + "_" + buf_num + "_" + loop + "_log/simple_crypto.uboot.log", "w+")
	p.logfile_read = fd

	p.sendline("")
	p.expect("=> ")
	p.sendline("\n")
	p.expect("=> ")
	p.sendline("pixis_reset altbank\n")
	p.expect("=> ")
	p.expect("Bank")
	p.expect("=> ")
	p.sendline("\n")
	fd2.write("Switched to u-boot bank 4\n")

	fd1 = open("logs/" + host + "_" + algo + "_" + buf_size + "_" + buf_num + "_" + loop + "_log/simple_crypto.uboot.log", "r")
	lines = fd1.readlines()
	fd1.close()
	for i in lines:
		if i.rfind("vBank: 4") > 0:
			bank4=1
			break
	if bank4:
		if r_flag:
			fd2.write("booting images from RAM\n")
			p.expect("=> ")
			p.sendline("setenv my_hv tftp 0x01000000 " + r_path + "/hv.uImage")
			p.expect("=> ")
			p.sendline("setenv my_dtb tftp 0x00c00000 " + r_path + "/p4080ds.dtb")
			p.expect("=> ")
			p.sendline("setenv my_spec tftp 0x00900000 " + r_path + "/hv-2p-lnx-lwe.dtb")
			p.expect("=> ")
			p.sendline("setenv my_fs tftp 0x41000000 " + r_path + "/rootfs.ext2.gz.uboot")
			p.expect("=> ")
			p.sendline("setenv my_kern tftp 0x40000000 " + r_path + "/uImage")
			p.expect("=> ")
			p.sendline("setenv bootargs config-addr=0x00900000")
			p.expect("=> ")
			p.sendline("setenv my_boot bootm 0x01000000 - 0x00c00000")
			p.expect("=> ")
			p.sendline("setenv boot run my_hv my_dtb my_spec my_fs my_kern my_boot")
			time.sleep(2)
			p.expect("=> ")
			p.sendline("run boot")
			time.sleep(1)
		else:
			fd2.write("booting images from flash\n")
			p.expect("=> ")
			p.sendline("setenv bootargs config-addr=0xfe8900000;")
			time.sleep(2)
			p.expect("=> ")
			p.sendline("bootm 0xfe8700000 - 0xfe8800000;")
			time.sleep(1)

		p.expect("HV> ")
	 	p.sendline("")
		p.expect("guest p1-linux")
		p.expect("HV> ")

		# close the file
		fd.close()
	else:
		fd2.write("Something wrong on Bank 4.... exiting\n")
		sys.exit(4)
	p.close()
	fd2.close()

