# Copyright (C) 2010 Freescale Semiconductor, Inc.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
# NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

import pexpect
import time
import sys

p=0
mux_server=""

def run_board(host, user, board, mux_port_string):
	global p
	board_reset_command = "skermit -reset " + board
	mux_server_command = "./mux_server -exec 'skermit -con " + board + "' " + mux_port_string

	p=pexpect.spawn("ssh " + host + " -l " + user)
	fd = open("ssh_logs", "w")
	p.logfile = fd
	p.timeout=1000000

	p.expect("$")
	time.sleep(6)
	p.sendline(board_reset_command)
	p.expect("$")
	time.sleep(6)
	p.sendline(mux_server_command)
	p.expect("using speed")

def kill_ps_mux_board():
	global p, mux_server
	mux_server="./mux_server -exec 'skermit -con " + board + "' " + mux_port_string
	kill_command="kill -9 'ps -eo pid,user,cmd | grep " + str(user) + " | grep \"" + mux_server + "\"  |grep -v grep | head -1 | cut -c 1-5'"

	p.sendline("\n\n")
	p.sendline(kill_command)
	p.expect("$")
	p.sendline("exit")
