# Copyright (C) 2010 Freescale Semiconductor, Inc.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
# NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


# This script connects to the linux partition running on the mux server
# and dumps its log in simple_pme_linux.log file

import sys

sys.path.append("../../common_scripts")

import time
import pexpect

app_name = "simple_pme.elf"
app_dir = "/opt/lwe_apps/simple_pme/"

def linux_partition(host, port, core_mask, test_script):
	# spawn the telnet session to the mux server linux port
	p=pexpect.spawn("telnet " + host + " " + str(port))
	p.timeout = 1000000

	# open file for dumping logs
	fd = open(host + "_" + test_script + "_log/simple_pme.linux.log", "w")

	p.logfile = fd

	# start the login sequence and send commands
	p.expect("ogin:")
	p.sendline("root")
	p.expect("assword:")
	p.sendline("root")
	p.expect("#")
	p.sendline("pmm")
	p.expect("pmm>")
	p.sendline("add regex file source " + app_dir + "spa_pattern")
	p.expect("pmm>")
	p.sendline("commit")
	p.expect("pmm>")
	p.sendline("quit")
	p.expect("#")
	p.sendline("partman status")
	p.expect("#")
	p.sendline("partman setprop -h `partman status | grep lwe | head -1 | awk \'{print $2}\'` -p chosen -n bootargs -t \"coremask=" + core_mask + "\"")
	p.expect("#")
	p.sendline("cd " + app_dir)
	p.expect("#")
	p.sendline("partman start -h  `partman status | grep lwe | head -1 | awk \'{print $2}\'`" + " -f ./" + app_name)
	p.expect("#")
	p.sendline("./" + test_script)
	time.sleep(5)
	p.expect("PME Application Started successfully")
	p.sendline("\n")
	time.sleep(15)
	p.expect("#")
	p.sendline("")

	# close log file
	fd.close()
