#!/usr/bin/env python
# 
#  Copyright (C) 2009 Freescale Semiconductor, Inc.
# 
#  Redistribution and use in source and binary forms, with or without
#  modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
# NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

import sys
import os
from scapy.all import *


def add_pay_load(pkts, payload_file, size):
        all_pkts = [p for p in pkts]
        num_pkts = len(all_pkts)
        if os.path.isfile(payload_file):
		fh = open(payload_file,"rb")
		# add payload.
		for p in all_pkts:
			load = fh.read (size)
			if len(load) != size:
				print "Not enough data in %s"%payload_file
				break
			print ".",
			p.payload.remove_payload()
			p.payload.add_payload(load)
		fh.close ()
        else:
		print "payload file not found"
	return all_pkts

def usage():
	print
	print "Usage: %s <pcap file> <payload_file> <size of Payload> <output pcap file>"%(sys.argv[0])
	print
	sys.exit(1)

if len(sys.argv) != 5:
	usage()
	sys.exit(1)
else:
	pcap_file = sys.argv[1]
	payload_file = sys.argv[2]
	payload_size = sys.argv[3]
	output_pcap = sys.argv[4]

if os.path.isfile(pcap_file):
        pkts = rdpcap(pcap_file)
else:
        "pcap file not found"

if os.path.isfile(payload_file):
	size = int(payload_size)
	print "adding payload",
        all_pkts = add_pay_load(pkts, payload_file, size)
	wrpcap(output_pcap,all_pkts)
else:
        print "payload file not found"
	usage()

